"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* tslint:disable:no-console */
const chalk = require("chalk");
class RegLogger {
    constructor(_category = "reg-suit") {
        this._category = _category;
        this._level = "info";
    }
    setLevel(v) {
        this._level = v;
    }
    get colors() {
        return chalk;
    }
    set colors(v) {
        return;
    }
    info(msg) {
        if (this._level !== "silent") {
            console.log(this._prefix + this.colors.green("info ") + msg);
        }
    }
    warn(msg) {
        if (this._level !== "silent") {
            console.warn(this._prefix + this.colors.bgYellow("warn ") + msg);
        }
    }
    error(obj) {
        if (this._level !== "silent") {
            if (typeof obj === "string") {
                console.error(this._prefix + this.colors.red("error ") + obj);
            }
            else {
                console.error(this._prefix + this.colors.red("error "), obj);
            }
        }
    }
    verbose(msg, ...objects) {
        if (this._level === "verbose") {
            console.log(this._prefix + this.colors.green("debug ") + msg);
            if (objects && objects.length) {
                objects.forEach(obj => {
                    console.log(this.colors.gray(JSON.stringify(obj, null, 2)));
                });
            }
        }
    }
    get _prefix() {
        return `[${this._category}] `;
    }
}
exports.RegLogger = RegLogger;
const regLogger = new RegLogger();
exports.default = regLogger;
